
#define PROGRESSBAR_FILLED_CHAR '#'
#define PROGRESSBAR_EMPTY_CHAR '-'

#define CLIENTS_CONNECTED_MSG "Clients connected:"
#define FILE_SIZE_MSG "Size:"

void initialize_curses();
void winresize_callback(int signum);
void draw_screen(server_t *server);
int print_client_info(int row, client_t *client);
char *progress_bar(ssize_t sent, ssize_t total, unsigned int bar_len);
float kilobytes_per_second(time_t start, time_t now, ssize_t sent);
char *percentage(ssize_t sent, ssize_t total);
char *estimated_time_left(time_t start, time_t now, ssize_t sent, ssize_t total);
char *readable_size(ssize_t size);


