#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <curses.h>
#include <signal.h>

#include "hfo.h"
#include "server.h"
#include "curses.h"

int main(int argc, char **argv) {

    server_t *server;
    /*
    struct tm *tim;
    time_t t;
    */
    int port;
    int ch;
    int c;
    int update = 0;
    
    while ((c = getopt(argc, argv, "p:")) != -1) {
        switch (c) {
            case '?':
                fprintf(stderr, "Unrecognized option: -%c\n", optopt);
                exit(-1);
                break;
            case 'p':
                port = atoi(optarg);
                break;
        }
    }
    signal(SIGPIPE, SIG_IGN);
    if ((server = setup_server(NULL, port)) == NULL) {
        fprintf(stderr, "Unable to create server.\nExiting!\n");
        exit(-1);
    }
    /* number of files in file base */
    server->filenum = argc-optind;
    server->filebase = (char **) malloc(server->filenum*sizeof(char *)); 
    /* save pointers to all files */
    for (c = 0; c < server->filenum; c++)
        server->filebase[c] = argv[optind++];
    
    /*
    for (c = 0; c < server->filenum; c++)
        printf("FB: %s\n", server->filebase[c]);
    */
    /* printf("filenum: %d\n", server->filenum); */
    initialize_curses(); 
    
    while (1) {
        if ((ch = getch()) != ERR) {
            switch (ch) {
                case 113:
                    server = shutdown_server(server);
                    endwin();
                    exit(0);
            }
        }        
        if (update == 0) {
            draw_screen(server); 
            update = 75;
        }
        update--;
        /*
        t = time(NULL);
        tim = localtime(&t);
        if (tim->tm_sec % 2 == 0)
            draw_screen(server);
        */
        get_connections(server);
        if (server->numclients > 0) {
            read_requests(server); 
        
            send_files(server);
        }
        /* printf("sent: %d\n", server->client[0].sent); */
    }
    return 0;

}
